#!/usr/local/bin/perl
use strict;
#-------------------------------------------------------------------------------
# Split from Satsuki::DB_pseudo.pm for AUTOLOAD.
#-------------------------------------------------------------------------------
use Satsuki::DB_pseudo ();
package Satsuki::DB_pseudo;
our $filename_format;
###############################################################################
# ơ֥
###############################################################################
#------------------------------------------------------------------------------
# create table
#------------------------------------------------------------------------------
sub create_table {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	my ($table, $colums) = @_;
	$table =~ s/\W//g;
	if ($table eq '') {  $ROBJ->error('Called create_table() with null table name'); return 9; }

	# ơ֥빽¤β
	my @cols       = ('pkey');	# pkey : ƬǽΥ
	my @index_cols = ('pkey');
	my $index_only = 1;
	my @num_cols;
	my @flag_cols;
	foreach(@$colums) {
		my $col = $_->{name};
		$col =~ s/\W//g;
		if ($col eq '') { next; }
		push(@cols, $col);
		if    ($_->{type} eq 'int')  { push(@num_cols,  $col); }
		elsif ($_->{type} eq 'flag') { push(@flag_cols, $col); }
		# ʳ text Ȥư
		if ($_->{index}) { push(@index_cols, $col); }
			    else { $index_only = 0; }
	}

	my $dir = $ROBJ->get_filepath( $self->{dir} . $table . '/' );
	if (!-e $dir) {
		if (! $ROBJ->mkdir($dir) ) { $ROBJ->error("mkdir '$dir' error : $!"); }
	}
	if ($table =~ /^\d/) {
		$ROBJ->error("To be a 'a-z' or '_' at the first character of a table name : '%s'", $table);
		return 1;
	}
	my $index = $dir . $self->{index_file};
	if (-e $index) {
		$ROBJ->error("'%s' table already exists", $table);
		return 1;
	}

	$self->{"$table.tbl"}        = [];		# table array ref
	$self->{"$table.cols"}       = \@cols;		# ѥ̾
	$self->{"$table.idx"}        = \@index_cols;	# index array ref
	$self->{"$table.num"}        = \@num_cols;	# num  array ref
	$self->{"$table.flag"}       = \@flag_cols;	# flag array ref
	$self->{"$table.index_only"} = $index_only;	# index only flag
	$self->{"$table.serial"}     = 0;

	# index ¸
	$self->save_index($table);
	# index ͽ¸
	my $index_file_orig = $self->{index_file};
	$self->{index_file} = $self->{index_backup_file};
	$self->save_index($table);
	$self->{index_file} = $index_file_orig;

	return 0;
}

#------------------------------------------------------------------------------
# ơ֥κ
#------------------------------------------------------------------------------
#  0 ֤
sub drop_table {
	my ($self, $table) = @_;
	my $ROBJ = $self->{ROBJ};
	$table =~ s/\W//g;

	my $dir = $self->{dir} . $table . '/';
	if (!-e $dir) { return 1; }	# Not found

	my $files = $ROBJ->search_files($dir);
	my $flag = 0;
	foreach(@$files) {
		if (! unlink("$dir$_")) { $flag += 2; }
	}
	if (!rmdir($dir)) { $flag+=10000; }
	return $flag;
}

#-------------------------------------------------------------------------------
# index κƹ
#-------------------------------------------------------------------------------
sub index_rebilud {
	my ($self, $table) = @_;
	my $ROBJ = $self->{ROBJ};
	$table =~ s/\W//g;

	my $dir = $ROBJ->get_filepath( $self->{dir} . $table . '/' );
	my $index_backup_file = $dir . $self->{index_backup_file};
	if (!-r $index_backup_file) { return 1; }

	# Хååפɤ߹
	my $index_file_orig = $self->{index_file};
	$self->{index_file} = $self->{index_backup_file};
	my $db = $self->load_index($table);
	$self->{index_file} = $index_file_orig;

	# եꥹȼ
	my $files   = $ROBJ->search_files($dir);
	my $file_ex = $self->{file_ex};
	my @files   = grep(/^\d+$file_ex$/, @$files);
	my @db;
	my $h;
	my $serial = 0;
	foreach(@files) {
		$h = $ROBJ->fread_hash($dir . $_);
		push(@db, $h);
		if ($serial < $h->{pkey}) { $serial = $h->{pkey}; } 
	}
	my @newary = sort { $a->{pkey} <=> $b->{pkey} } @db;

	$self->{"$table.serial"} = $serial +1;
	$self->{"$table.tbl"}    = \@newary;
	$self->save_index($table);
}

###############################################################################
# ǡ
###############################################################################
#-------------------------------------------------------------------------------
# ǡ
#------------------------------------------------------------------------------
sub insert {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	my ($table, $h, $save_pkey) = @_;
	$table =~ s/\W//g;

	my $db = $self->load_index($table, 1);
	if (!defined $db) {
		$self->edit_index_exit($table);
		$ROBJ->error("Can't find '%s' table", $table);
		return 0;
	}
	$h = $self->check_column($table, $h);

	my $dir        = $self->{dir} . $table . '/';
	my $index_only = $self->{"$table.index_only"};
	my $serial     = $self->{"$table.serial"};
	my $pkey;
	if ($save_pkey) {
		$pkey = int($h->{pkey});
		if ($pkey < 1) { return 0; }
		# ʣʤå
		foreach(@$db) {
			if ($_->{pkey} == $pkey) { return 0; }	# fail
		}
		$h->{pkey} = $pkey;
		if ($serial < $pkey) { $serial = $pkey; }
	} else {
		$pkey = $h->{pkey} = ++$serial;	# pkey
	}
	$self->{"$table.serial"} = $serial;
	push(@$db, $h);			# add
	if (! $index_only) {
		my $str = sprintf($filename_format, $pkey);
		$ROBJ->fwrite_hash($dir . $str . $self->{file_ex}, $h);		# save hash
	}
	my $r = $self->save_index($table);
	if ($r) { return 0; }	# 
	return $pkey;		# 
}

#-------------------------------------------------------------------------------
# ǡι
#------------------------------------------------------------------------------
sub update_match {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	my ($table, $h, $match_col, $value, $match_col2, $value2, $match_col3, $value3) = @_;
	$table =~ s/\W//g;

	my $db   = $self->load_index($table, 1);
	my $dir  = $self->{dir} . $table . '/';
	my $index_only = $self->{"$table.index_only"};
	if (!defined $db) {
		$self->edit_index_exit($table);
		$ROBJ->error("Can't find '%s' table", $table);
		return 0;
	}

	# ɬפʥγǧ
	my $index_cols = $self->{"$table.idx"};
	my ($m1,$m2,$m3) = ($match_col, $match_col2, $match_col3);
	foreach(@$index_cols) {
		if ($m1 eq $_) { $m1=''; }
		if ($m2 eq $_) { $m2=''; }
		if ($m3 eq $_) { $m3=''; }
	}
	if ($m1 ne '' || $m2 ne '' || $m3 ne '') {
		my $file_ex = $self->{file_ex};
		$db = [ map { $ROBJ->fread_hash_cached($dir . sprintf($filename_format, $_->{pkey}). $file_ex) } @$db ];
		$self->{"$table.tbl"} = $db;
	}

	# ޥåϥå˳Ǽ
	my %match;
	if (ref($value)) {
		foreach(@$value) { $match{$_} = 1; }
	} else {
		$match{$value} = 1;
	}

	# ˥ޥå륫񤭴
	my $updates = 0;
	foreach(@$db) {
		if ($match_col  ne '' && ! $match{ $_->{$match_col} }) { next; }
		if ($match_col2 ne '' && $_->{$match_col2} ne $value2) { next; }
		if ($match_col3 ne '' && $_->{$match_col3} ne $value3) { next; }

		# ݻ񤭴
		$updates++;
		my $pkey = $_->{pkey};
		my $file = $dir . sprintf($filename_format, $pkey) . $self->{file_ex};
		if (! $index_only) { $_ = $ROBJ->fread_hash($file); }
		while(my ($k,$v) = each(%$h)) {
			if ($k eq 'pkey') { next; }
			$_->{$k} = $v; 	# replace
		}
		# save hash
		if (! $index_only) { $ROBJ->fwrite_hash($file, $_); }
	}
	if ($updates) {
		my $r = $self->save_index($table);	# Խ̤¸
		if ($r) { return 0; }	# 
	} else {
		$self->edit_index_exit($table);		# Խνλ
	}
	return $updates;		# 
}
#-------------------------------------------------------------------------------
# ǡκ
#------------------------------------------------------------------------------
sub delete_match {
	my ($self, $table, $match_col, $value, $match_col2, $value2, $match_col3, $value3) = @_;
	my $ROBJ = $self->{ROBJ};
	$table =~ s/\W//g;

	my $db         = $self->load_index($table, 1);
	my $dir        = $self->{dir} . $table . '/';
	my $index_only = $self->{"$table.idx"};
	if (!defined $db) {
		$self->edit_index_exit($table);
		$ROBJ->error("Can't find '%s' table", $table);
		return 0;
	}

	# ɬפʥγǧ
	my $index_cols = $self->{"$table.idx"};
	my ($m1,$m2,$m3) = ($match_col, $match_col2, $match_col3);
	foreach(@$index_cols) {
		if ($m1 eq $_) { $m1=''; }
		if ($m2 eq $_) { $m2=''; }
		if ($m3 eq $_) { $m3=''; }
	}
	if ($m1 ne '' || $m2 ne '' || $m3 ne '') {
		my $file_ex = $self->{file_ex};
		$db = [ map { $ROBJ->fread_hash_cached($dir . sprintf($filename_format, $_->{pkey}). $file_ex) } @$db ];
		$self->{"$table.tbl"} = $db;
	}

	# ޥåϥå˳Ǽ
	my %match;
	if (ref($value)) {
		foreach(@$value) { $match{$_} = 1; }
	} else {
		$match{$value} = 1;
	}

	my @newary;
	my $count;
	foreach(@$db) {
		if ($match_col  ne '' && ! $match{ $_->{$match_col} }) { push(@newary, $_); next; }
		if ($match_col2 ne '' && $_->{$match_col2} ne $value2) { next; }
		if ($match_col3 ne '' && $_->{$match_col3} ne $value3) { next; }
		# 
		my $str = sprintf($filename_format, $_->{pkey});
		unlink($dir . $str . $self->{file_ex});
		$count++;
	}
	$self->{"$table.tbl"} = \@newary;
	$self->save_index($table);

	return $count;
}
###############################################################################
# ơν
###############################################################################
#------------------------------------------------------------------------------
# ơ֥ξ򽸷
#------------------------------------------------------------------------------
sub select_by_group {
	my ($self, $table, $h) = @_;
	my $ROBJ = $self->{ROBJ};
	$table =~ s/\W//g;

	my $group_col = $h->{group_col};
	my $sum_col   = $h->{sum_col};
	my $max_col   = $h->{max_col};
	my $min_col   = $h->{min_col};
	my $match_col = $h->{match_col};
	my $match_val = $h->{match_val};
	my $match;
	if ($match_col ne '') { $match=1; }

	#---------------------------------------------
	# ǡΥ
	#---------------------------------------------
	my $db = $self->load_index($table);	# table array ref

	#---------------------------------------------
	# 롼ԥ󥰤Ƚ׽
	#---------------------------------------------
	my %group;
	my %sum;
	my %max;
	my %min;
	foreach(@$db) {
		if ($match && $_->{$match_col} ne $match_val) { next; }	# ޥåʤ
		my $group;
		$group_col ne '' && ($group = $_->{$group_col});
		$group{ $group } ++;
		$sum  { $group } += $_->{$sum_col};
		if (!exists $min{$group}) { $min{$group}=$_->{$min_col}; }
		if (!exists $max{$group}) { $max{$group}=$_->{$max_col}; }
		$min{$group} > $_->{$min_col} && ($min{$group} = $_->{$min_col});
		$max{$group} < $_->{$max_col} && ($max{$group} = $_->{$max_col});
	}

	#---------------------------------------------
	# ̤
	#---------------------------------------------
	my @newary;
	if ($sum_col ne '') { $sum_col=1; }
	while(my ($k,$v) = each(%group)) {
		my %h;
		$h{$group_col} = $k;
		$h{_count}     = $v;
		$sum_col && ($h{_sum} = $sum{$k});
		$max_col && ($h{_max} = $max{$k});
		$min_col && ($h{_min} = $min{$k});
		push(@newary, \%h);
	}

	#---------------------------------------------
	# Ƚ
	#---------------------------------------------
	my $sort = $h->{sort};
	if ($sort ne '') {
		if ($self->check_type_str($table, $sort)) {
			if ($h->{sort_reverse}) { @newary = sort {$b->{$sort} cmp $a->{$sort}} @newary; }
					else    { @newary = sort {$a->{$sort} cmp $b->{$sort}} @newary; }
		} else {
			if ($h->{sort_reverse}) { @newary = sort {$b->{$sort} <=> $a->{$sort}} @newary; }
					else    { @newary = sort {$a->{$sort} <=> $b->{$sort}} @newary; }
		}
	}

	return \@newary;
}

###############################################################################
# ֥롼
###############################################################################
#------------------------------------------------------------------------------
# index Υ
#------------------------------------------------------------------------------
sub save_index {
	my $self    = shift;
	my $ROBJ    = $self->{ROBJ};
	my ($table) = @_;

	my $db        = $self->{"$table.tbl"};		# table array ref
	my $cols      = $self->{"$table.cols"};		# ̾
	my $idx_cols  = $self->{"$table.idx"};		# index array ref
	my $idx_only  = $self->{"$table.index_only"}+0;	# index only flag
	my $num_cols  = $self->{"$table.num"};		# array ref
	my $flag_cols = $self->{"$table.flag"};		# array ref
	my $serial    = $self->{"$table.serial"}    +0;	# serial
	my @newary = sort { $a->{pkey} <=> $b->{pkey} } @$db;
	$self->{"$table.tbl"} = \@newary;	# ݻ񤭴

	# ܥǥåflagܥꥢ
	# 󡿣index
	my @lines;
	push(@lines, "3\n$idx_only\n$serial\n");	# 4 = DB-file Version
	push(@lines, join("\t", @$cols) . "\n");
	push(@lines, join("\t", @$num_cols)  . "\n");
	push(@lines, join("\t", @$flag_cols) . "\n");
	push(@lines, join("\t", @$idx_cols)  . "\n");

	my $h;
	foreach $h (@newary) {
		my $line;
		foreach (@$idx_cols) {
			$h->{$_} =~ s/[\t\n]//g;	# TAB, Ԥν
			$line .= $h->{$_} . "\t";
		}
		chop($line);
		push(@lines, $line . "\n");
	}

	# save
	my $dir   = $self->{dir} . $table . '/';
	my $index = $dir . $self->{index_file};
	# unlock
	if (defined $self->{"$table.lock"}) {
		my $r = $ROBJ->fedit_writelines($index, $self->{"$table.lock"}, \@lines);
		undef $self->{"$table.lock"};
		return $r;
	}
	return $ROBJ->fwrite_lines($index, \@lines);
}

#------------------------------------------------------------------------------
# indexԽ˴
#------------------------------------------------------------------------------
sub edit_index_exit {
	my ($self, $table) = @_;
	if (defined $self->{"$table.lock"}) {
		my $index_file = $self->{dir} . $table . '/' . $self->{index_file};
		$self->{ROBJ}->fedit_exit($index_file, $self->{"$table.lock"});
		undef $self->{"$table.lock"};
	}
}

#------------------------------------------------------------------------------
# column ̾Υå
#------------------------------------------------------------------------------
sub check_column {
	my ($self, $table, $hash) = @_;
	my $cols      = $self->{"$table.cols"};
	my $num_cols  = $self->{"$table.num"}  || [];
	my $flag_cols = $self->{"$table.flag"} || [];

	# ͤ򥳥ԡ˲ɻߡ
	my %h = %$hash;
	# ¸ߤ륫̾򥳥ԡ
	my %new_hash;
	foreach (@$cols) {
		if (exists $h{$_}) { $new_hash{$_} = $h{$_}; delete $h{$_}; }
	}
	# 
	foreach (@$num_cols)  {
		if (exists $new_hash{$_}) { $new_hash{$_} = int($new_hash{$_}); }
	}
	# ե饰
	foreach (@$flag_cols) {
		if (exists $new_hash{$_}) {
			$new_hash{$_} = $new_hash{$_} ? 1 : 0;
		}
	}
	# ¸ߤʤ̾򥨥顼Ȥƽ
	foreach(keys(%h)) {
		$self->{ROBJ}->error("On '%s' table, not exists '%s' column", $table, $_);
	}
	return \%new_hash;
}

1;	# ޤʤ
