#!/usr/local/bin/perl
use strict;
#-------------------------------------------------------------------------------
# Split from Satsuki::DB_pseudo.pm for AUTOLOAD.
#-------------------------------------------------------------------------------
# optional functions
use Satsuki::DB_pseudo ();
use Satsuki::DB_pseudo_auto ();
package Satsuki::DB_pseudo;
our $filename_format;
###############################################################################
# ץʥؿ
###############################################################################
sub get_options {
	return {add_column => 1, drop_column => 1, add_index => 1};
}
###############################################################################
# ץʥؿ
###############################################################################
#------------------------------------------------------------------------------
# ɲ
#------------------------------------------------------------------------------
sub add_column {
	my ($self, $table, $h) = @_;
	my $dbh  = $self->{dbh};
	my $ROBJ = $self->{ROBJ};

	# ơ֥index Υ
	$table =~ s/\W//g;
	my $db = $self->load_index($table, 1);
	if (!defined $db) {
		$self->edit_index_exit($table);
		$ROBJ->error("Can't find '%s' table", $table);
		return 9;
	}

	my $col = $h->{name};
	$col =~ s/\W//g;
	if ($col eq '') { return 8; }
	# ơ֥ν񤭴
	my $cols = $self->{"$table.cols"};
	if ( grep { $_ eq $col } @$cols ) {	# Ʊ̾Υब
		$self->edit_index_exit($table);
		$ROBJ->error("'%s' is already exists in relation '%s'", $col, $table);
		return 8;
	}
	push(@{ $self->{"$table.cols"}}, $col);
	if ($h->{index}) { push(@{ $self->{"$table.idx"}}, $col); }
	if ($h->{type} eq 'int')  { push(@{ $self->{"$table.num"} }, $col); }
	if ($h->{type} eq 'flag') { push(@{ $self->{"$table.flag"}}, $col); }

	# index ¸
	$self->save_index($table);
	$self->save_backup_index($table);
	# å奯ꥢ
	$self->{"$table.tbl"} = undef;

	return 0;
}

#------------------------------------------------------------------------------
# κ
#------------------------------------------------------------------------------
sub drop_column {
	my ($self, $table, $column) = @_;
	my $dbh  = $self->{dbh};
	my $ROBJ = $self->{ROBJ};
	$table  =~ s/\W//g;
	$column =~ s/\W//g;
	if ($table eq '' || $column eq '') { return 9; }

	# ơ֥index Υ
	$table =~ s/\W//g;
	my $db = $self->load_index($table, 1);
	if (!defined $db) {
		$self->edit_index_exit($table);
		$ROBJ->error("Can't find '%s' table", $table);
		return 9;
	}
	# ơ֥ν񤭴
	$self->{"$table.cols"} = [ grep {$_ ne $column} @{$self->{"$table.cols"}} ];
	$self->{"$table.idx"}  = [ grep {$_ ne $column} @{$self->{"$table.idx"}}  ];
	$self->{"$table.num"}  = [ grep {$_ ne $column} @{$self->{"$table.num"}}  ];
	$self->{"$table.flag"} = [ grep {$_ ne $column} @{$self->{"$table.flag"}} ];

	# index ¸
	$self->save_index($table);
	$self->save_backup_index($table);
	# å奯ꥢ
	$self->{"$table.tbl"} = undef;

	return 0;
}

#------------------------------------------------------------------------------
# ǥåɲ
#------------------------------------------------------------------------------
sub add_index {
	my ($self, $table, $column) = @_;
	my $dbh  = $self->{dbh};
	my $ROBJ = $self->{ROBJ};

	# ơ֥index Υ
	$table =~ s/\W//g;
	my $db = $self->load_index($table, 1);
	if (!defined $db) {
		$self->edit_index_exit($table);
		$ROBJ->error("Can't find '%s' table", $table);
		return 9;
	}

	# ơ֥ν񤭴
	my $cols = $self->{"$table.cols"};
	my $idx  = $self->{"$table.idx"};
	if (! grep { $_ eq $column } @$cols) {	# ब¸ߤʤ
		$self->edit_index_exit($table);
		$self->{ROBJ}->error("On '%s' table, not exists '%s' column", $table, $column);
		return 8;
	}
	if (! grep { $_ eq $column } @$idx) {	# index ɲ
		push(@$idx, $column);
		my $dir     = $self->{dir} . $table . '/';
		my $file_ex = $self->{file_ex};
		$self->{"$table.tbl"} = [ map { $ROBJ->fread_hash_cached($dir . sprintf($filename_format, $_->{pkey}). $file_ex) } @$db ];
	}
	# index ¸
	$self->save_index($table);
	$self->save_backup_index($table);

	return 0;
}

###############################################################################
# ֥롼
###############################################################################
#------------------------------------------------------------------------------
# Хååץեν񤭴
#------------------------------------------------------------------------------
sub save_backup_index {
	my $self  = shift;
	my $table = shift;
	# index ͽ¸
	my $index_file_orig = $self->{index_file};
	$self->{index_file} = $self->{index_backup_file};
	local ($self->{"$table.tbl"}) = [];
	$self->save_index($table);
	$self->{index_file} = $index_file_orig;
	return 0;
}

1;	# ޤʤ
